void doDMA0(unsigned long rt)
 {
    psxHL[0x1088>>2]=rt & 0xfeffffff;
    if (rt & 0x01000000) DMAintr(1);
    do_DMA0(psxHL[0x1080>>2], psxHL[0x1084>>2], rt);
    if (cdV != 0xffffffff) cdV+=3;
 }

void doDMA1(unsigned long rt)
 {
    psxHL[0x1098>>2]=rt & 0xfeffffff;
    if (rt & 0x01000000) DMAintr(2);
    do_DMA1(psxHL[0x1090>>2], psxHL[0x1094>>2], rt);
 }

void doDMA2(unsigned long rt)
 {
    psxHL[0x10a8>>2]=rt & 0xfeffffff;
    if (rt == 0x01000401)
     { GPU_dmaChain((void*)psxM, psxHL[0x10a0>>2]&0x1fffff);
       DMAintr(4);
     }
    else if (rt == 0x01000201)
     {
      unsigned long size, *madr;
      madr=(void*)psxM+(psxHL[0x10a0>>2]&0x1fffff);
      size=(psxHL[0x10a4>>2]&0xffff)*(psxHL[0x10a4>>2]>>16);
      if (NEWGPU) GPU_writeDataMem(madr,size);
      else while (size>0) { GPU_writeData(*madr); size--; madr++; }
      DMAintr(4);
     }
    else if (rt == 0x01000200)
     {
      unsigned long size, *madr;
      madr=(void*)psxM+(psxHL[0x10a0>>2]&0x1fffff);
      size=(psxHL[0x10a4>>2]&0xffff)*(psxHL[0x10a4>>2]>>16);
      while (size>0) { madr[0]=GPU_readData(); size--; madr++; }
      DMAintr(4);
     }
 }

void doDMA3(unsigned long rt)
 {
    unsigned long register cdaddr, cdsize;
    psxHL[0x10b8>>2] = rt & 0xfeffffff;
    if ((rt&0x11000000) != 0x11000000) return;
    DMAintr(8);

    if (rread)
     {
       CD_Read(cdSetSector);
       incSector();
       rread=0; cdpos=0; cdReaded++;
     }

      cdaddr= psxHL[0x10b0>>2] & 0x1fffff;
      cdsize= psxHL[0x10b4>>2] & 0xffff;

      if ( (cdsize>585) || (cdsize==0) )
       {
        exit(0);
       }

      CleanRec(cdaddr, cdsize*4);

      if ((psxHL[0x10b4>>2]>>16) > 1) { exit(1); }

      if (psxHL[0x10b0>>2]&0x5f800000)
       {
        cdpos+=cdsize*4;
        if ( (cdpos>=2340) && (((cdMode>>4)&3)==2) ) cdOCUP=0;
        else if (cdpos>=2340) cdOCUP=0;
        return;
       }

      if ((psxHL[0x10b4>>2]>>16) == 0)
       {
        memcpy32(psxM+(cdaddr), RAWCDROM+24+cdpos, cdsize);
        cdpos+=cdsize*4;
        if (cdpos>=2048) cdOCUP=0;
       }
      else if (((cdMode>>4)&3)==2)
       {
        memcpy32(psxM+(cdaddr), RAWCDROM+12+cdpos, cdsize);
        cdpos+=cdsize*4;
        if (cdpos>=2340) cdOCUP=0;
       }
      else
       {
        memcpy32(psxM+(cdaddr), RAWCDROM+24+cdpos, cdsize);
        cdpos+=cdsize*4;
        if (cdpos>=2048) cdOCUP=0;
       }
 }

void doDMA4(unsigned long rt)
 {
    if (SPUDEC) dma4_exec(psxHL[0x10c0>>2],psxHL[0x10c4>>2], rt);
    psxHL[0x10c8>>2] = rt & 0xfeffffff;
    DMAintr(16);
 }

void doDMA5(unsigned long rt)
 {
    psxHL[0x10d8>>2] = rt & 0xfeffffff;
    DMAintr(32);
 }

void doDMA6(unsigned long rt)
 {
    psxHL[0x10e8>>2]=rt & 0xfeffffff;
    if ((rt & 0x11000002) == 0x11000002) { DMAintr(64); clearOT(psxHL[0x10e0>>2],psxHL[0x10e4>>2]); }
 }
