void opLBU(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $14, %edx
andl $0x7c, %edx
addl $_reg, %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _READ8U

movl $0, _reg
");
}

void opLB(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $14, %edx
andl $0x7c, %edx
addl $_reg, %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _READ8S

movl $0, _reg
");
}

void opLHU(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $14, %edx
andl $0x7c, %edx
addl $_reg, %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _READ16U

movl $0, _reg
");
}

void opLH(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $14, %edx
andl $0x7c, %edx
addl $_reg, %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _READ16S

movl $0, _reg
");
}

void opLW(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $14, %edx
andl $0x7c, %edx
addl $_reg, %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _READ32

movl $0, _reg
");
}

void opSB(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $16, %edx
andl $0x1f, %edx
movl _reg(,%edx,4), %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _WRITE8
");
}


void opSH(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $16, %edx
andl $0x1f, %edx
movl _reg(,%edx,4), %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _WRITE16
");
}

void opSW(void)
{
asm("
movl _buff, %ecx

movl %ecx, %edx
shrl $16, %edx
andl $0x1f, %edx
movl _reg(,%edx,4), %edx

movl %ecx, %eax
shrl $21, %eax
andl $0x1f, %eax
movl _reg(,%eax,4), %eax
movswl %cx, %ecx
addl %ecx, %eax

call _WRITE32
");
}

void opSWR(void)
{
register unsigned long rt;
register unsigned long addrD;
register unsigned long *mempoint;

rt = reg[(buff >> 16) & 0x1f];
addrD = reg[(buff >> 21) & 0x1f] + (signed short)buff;
mempoint= (void*)psxMEMW[(addrD>>16)&0xffff]+(addrD&0xfffc);

switch (addrD&3)
 {
		case 3: mempoint[0] = (mempoint[0] & 0x00ffffff) | (rt<<24); break;
		case 2: mempoint[0] = (mempoint[0] & 0x0000ffff) | (rt<<16); break;
		case 1: mempoint[0] = (mempoint[0] & 0x000000ff) | (rt<< 8); break;
		case 0: mempoint[0] = rt; break;
 }
}

void opSWL(void)
{
register unsigned long rt;
register unsigned long addrD;
register unsigned long *mempoint;

rt = reg[(buff >> 16) & 0x1f];
addrD = reg[(buff >> 21) & 0x1f] + (signed short)buff;
mempoint= (void*)psxMEMW[(addrD>>16)&0xffff]+(addrD&0xfffc);

switch (addrD&3)
 {		case 3: mempoint[0] = rt; break;
		case 2: mempoint[0] = (mempoint[0] & 0xff000000) | (rt>> 8); break;
		case 1: mempoint[0] = (mempoint[0] & 0xffff0000) | (rt>>16); break;
		case 0: mempoint[0] = (mempoint[0] & 0xffffff00) | (rt>>24); break;
 }
}

void opLWR(void)
{
register unsigned long rt;
register unsigned long addrD;
register unsigned long *mempoint;

rt = (buff>>16)&0x1f;
if (!(rt)) return;
addrD = reg[(buff >> 21) & 0x1f] + (signed short)buff;
mempoint= (void*)psxMEM[(addrD>>16)&0xffff]+(addrD&0xfffc);

switch (addrD&3)
 {		case 0: reg[rt] = mempoint[0]; break;
		case 1: reg[rt] = (reg[rt] & 0xff000000) | (mempoint[0]>> 8); break;
		case 2: reg[rt] = (reg[rt] & 0xffff0000) | (mempoint[0]>>16); break;
		case 3: reg[rt] = (reg[rt] & 0xffffff00) | (mempoint[0]>>24); break;
 }
}


void opLWL(void)
{
register unsigned long rt;
register unsigned long addrD;
register unsigned long *mempoint;

rt = (buff>>16)&0x1f;
if (!(rt)) return;
addrD = reg[(buff >> 21) & 0x1f] + (signed short)buff;
mempoint= (void*)psxMEM[(addrD>>16)&0xffff]+(addrD&0xfffc);

switch (addrD&3)
 {		case 3: reg[rt] = mempoint[0]; break;
		case 2: reg[rt] = (reg[rt] & 0x000000ff) | (mempoint[0]<< 8); break;
		case 1: reg[rt] = (reg[rt] & 0x0000ffff) | (mempoint[0]<<16); break;
		case 0: reg[rt] = (reg[rt] & 0x00ffffff) | (mempoint[0]<<24); break;
 }
}
