#include "dma.h"

void (*WCD[4])(unsigned long rt) = { NULL, NULL, NULL, NULL };
unsigned long (*RCD[4])(void) = { NULL, NULL, NULL, NULL };
void (*doDMA[7])(unsigned long rt) = { doDMA0, doDMA1, doDMA2, doDMA3, doDMA4, doDMA5, doDMA6 };

void WRITE8HW(void)
{
unsigned long register addrD, rt;
asm("
andl $0xffff, %%eax
andl $0xff, %%edx
" : "=a"(addrD), "=d"(rt) );

if ((addrD>=0x1800) && (addrD<=0x1803)) WCD[addrD&3](rt);
else psxH[addrD] = rt;

}

void WRITE16HW(void)
{
unsigned long register addrD, rt;
asm("
andl $0xffff, %%eax
andl $0xffff, %%edx
" : "=a"(addrD), "=d"(rt) );

if ((addrD >= 0x1c00) && (addrD < 0x1e00) && SPUDEC)
   SPU_writeRegister(addrD|0x1f800000, (unsigned short)rt);

else
switch (addrD)
{
  case 0x10f6: //D_ICR
       psxHW[0x10f6>>1] = rt & 0x00ff;
       break;

  case 0x1070:
       psxHW[0x1070>>1]&= psxHW[0x1074>>1]&rt;
       psxHW[0x1070>>1]|=DoPAD;
       break;

  case 0x1104:
       psxHL[0x1104>>2] = rt;
       if (psxHL[0x1104>>2]&8) TargetRTC0=psxHL[0x1108>>2];else TargetRTC0=0xffff;
       if ( ((psxHL[0x1104>>2]&0x150)==0x50) && (TargetRTC0) ) NextRTC0=temporizer+TargetRTC0/800;
       else NextRTC0=0xffffffff;
       break;

  case 0x1108:
       psxHL[0x1108>>2] = rt;
       if (psxHL[0x1104>>2]&8) TargetRTC0=psxHL[0x1108>>2];else TargetRTC0=0xffff;
       if ( ((psxHL[0x1104>>2]&0x150)==0x50) && (TargetRTC0) ) NextRTC0=temporizer+TargetRTC0/800;
       else NextRTC0=0xffffffff;
       break;

  case 0x1114:
       psxHL[0x1114>>2] = rt;
       if (psxHL[0x1114>>2]&8) TargetRTC1=psxHL[0x1118>>2];else TargetRTC1=0xffff;
       if ( ((psxHL[0x1114>>2]&0x150)==0x150) && (TargetRTC1) ) NextRTC1=temporizer+TargetRTC1;
       else NextRTC1=0xffffffff;
       break;

  case 0x1118:
       psxHL[0x1118>>2] = rt;
       if (psxHL[0x1114>>2]&8) TargetRTC1=psxHL[0x1118>>2];else TargetRTC1=0xffff;
       if ( ((psxHL[0x1114>>2]&0x150)==0x150) && (TargetRTC1) ) NextRTC1=temporizer+TargetRTC1;
       else NextRTC1=0xffffffff;
       break;

  case 0x1124:
       psxHL[0x1124>>2] = rt;
       if (psxHL[0x1124>>2]&8) TargetRTC2=psxHL[0x1128>>2]; else TargetRTC2=0xffff;
       if ( ((psxHL[0x1124>>2]&0x250)==0x250) && (TargetRTC2) ) NextRTC2=temporizer+TargetRTC2/100;
       else NextRTC2=0xffffffff;
       break;

  case 0x1128:
       psxHL[0x1128>>2] = rt;
       if (psxHL[0x1124>>2]&8) TargetRTC2=psxHL[0x1128>>2]; else TargetRTC2=0xffff;
       if ( ((psxHL[0x1124>>2]&0x250)==0x250) && (TargetRTC2) ) NextRTC2=temporizer+TargetRTC2/100;
       else NextRTC2=0xffffffff;
       break;

  default:
       psxHW[addrD >> 1] = (unsigned short)rt;
       break;
}
}

void WRITE32HW(void)
{
unsigned long register addrD, rt;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

if ((addrD >= 0x1c00) && (addrD < 0x1e00) && SPUDEC)
   SPU_writeRegister(addrD|0x1f800000, (unsigned short)rt);
else

if ((addrD>=0x1080) && (addrD<0x10f0))
 {
  register unsigned long nDMA=((addrD-0x1088)>>4);
  if ((addrD&0xf)!=0x8) { psxHL[addrD>>2]=rt; return; }
  if (!(DMA_ACTIVE(nDMA))) { psxHL[addrD>>2]=rt; return; }
  if ((rt&0x01000000)==0) { psxHL[addrD>>2]=rt & 0xfeffffff; return; }
  doDMA[nDMA](rt);
 }
else
switch (addrD)
{
 case 0x1070:
       psxHL[0x1070>>2]&= psxHL[0x1074>>2]&rt;
       psxHW[0x1070>>1]|=DoPAD;
       break;

  case 0x10f4: //D_ICR
       psxHL[0x10f4>>2] = rt & 0x00ffffff;
       break;

  case 0x1810:
       GPU_writeData(rt);
       break;

  case 0x1814:
       GPU_writeStatus(rt);
       break;

  case 0x1820:
       mdec0_write(rt);
       break;

  case 0x1104:
       psxHL[0x1104>>2] = rt;
       if (psxHL[0x1104>>2]&8) TargetRTC0=psxHL[0x1108>>2];else TargetRTC0=0xffff;
       if ( ((psxHL[0x1104>>2]&0x150)==0x50) && (TargetRTC0) ) NextRTC0=temporizer+TargetRTC0/800;
       else NextRTC0=0xffffffff;
       break;

  case 0x1108:
       psxHL[0x1108>>2] = rt;
       if (psxHL[0x1104>>2]&8) TargetRTC0=psxHL[0x1108>>2];else TargetRTC0=0xffff;
       if ( ((psxHL[0x1104>>2]&0x150)==0x50) && (TargetRTC0) ) NextRTC0=temporizer+TargetRTC0/800;
       else NextRTC0=0xffffffff;
       break;

  case 0x1114:
       psxHL[0x1114>>2] = rt;
       if (psxHL[0x1114>>2]&8) TargetRTC1=psxHL[0x1118>>2];else TargetRTC1=0xffff;
       if ( ((psxHL[0x1114>>2]&0x150)==0x150) && (TargetRTC1) ) NextRTC1=temporizer+TargetRTC1;
       else NextRTC1=0xffffffff;
       break;

  case 0x1118:
       psxHL[0x1118>>2] = (unsigned short)rt;
       if (psxHL[0x1114>>2]&8) TargetRTC1=psxHL[0x1118>>2];else TargetRTC1=0xffff;
       if ( ((psxHL[0x1114>>2]&0x150)==0x150) && (TargetRTC1) ) NextRTC1=temporizer+TargetRTC1;
       else NextRTC1=0xffffffff;
       break;

  case 0x1124:
       psxHL[0x1124>>2] = rt;
       if (psxHL[0x1124>>2]&8) TargetRTC2=psxHL[0x1128>>2]; else TargetRTC2=0xffff;
       if ( ((psxHL[0x1124>>2]&0x250)==0x250) && (TargetRTC2) ) NextRTC2=temporizer+TargetRTC2/100;
       else NextRTC2=0xffffffff;
       break;

  case 0x1128:
       psxHL[0x1128>>2] = (unsigned short)rt;
       if (psxHL[0x1124>>2]&8) TargetRTC2=psxHL[0x1128>>2]; else TargetRTC2=0xffff;
       if ( ((psxHL[0x1124>>2]&0x250)==0x250) && (TargetRTC2) ) NextRTC2=temporizer+TargetRTC2/100;
       else NextRTC2=0xffffffff;
       break;

  default:
       psxHL[addrD >> 2] = rt;
  break;
}
}

void READ8UHW(void)
{
unsigned long register addrD, *rt, p;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

if ((addrD>=0x1800) && (addrD<=0x1803)) rt[0]=RCD[addrD&3]();
else
switch (addrD)
{
  case 0x1040: // SIO DATA
  rt[0]= 0x00;
  p=psxH[0x1040];
  if ((psxHW[0x104a>>1]&0xffef)==0x1003) // PAD 00
   {
    pad2m=0; pad2c=0;
    if (
    (psxH[0x1040] == 0x42) ||
    (psxH[0x1040] == 0x43) ||
    (psxH[0x1040] == 0x45)
    )
    { pad1m=1; pad1c=1; psxH[0x1040]=0; }


    if (pad1m)
     {
     rt[0]=(unsigned char)pad1d[pad1c];
     //DoPAD=0x0;
     pad1c++;
     if (pad1c == 5)
        {
         pad1m=0;
         pad1c=0;
        }
     }
   }
  else if ((psxHW[0x104a>>1]&0xffef)==0x3003) // PAD 00
   {
    pad1m=0; pad1c=0;
    if (
    (psxH[0x1040] == 0x42) ||
    (psxH[0x1040] == 0x43) ||
    (psxH[0x1040] == 0x45)
    )
    { pad2m=1; pad2c=1; psxH[0x1040]=0; }

    if (pad2m)
     {
     rt[0]=(unsigned char)pad2d[pad2c];
     //DoPAD=0x0;
     pad2c++;
     if (pad2c == 5)
        {
         pad2m=0;
         pad2c=0;
         DoPAD=0x0;
        }
     }
   }

  default:
  rt[0] = (unsigned char)psxH[addrD];
  break;
}
}

void READ8SHW(void)
{
unsigned long register addrD, *rt;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

switch (addrD)
{
  default:
  rt[0] = (signed char)psxH[addrD];
  break;
}
}

void READ16UHW(void)
{
unsigned long register addrD, *rt;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

if ((addrD >= 0x1c00) && (addrD < 0x1e00) && SPUDEC)
   rt[0]=(unsigned short)SPU_readRegister(addrD|0x1f800000);
else
switch (addrD)
{
  case 0x1044:
       rt[0] = psxHL[0x1044>>2]= 0xd02b; //0x422b; // SIO STATUS
       break;

  case 0x1100: //RTC0 READ
       if (psxHL[0x1104>>2]&0x100) rt[0]=(unsigned short)(rt[0]/5);
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  case 0x1110: //RTC1 READ
       if (psxHL[0x1114>>2]&0x100) rt[0]=(unsigned short)temporizer;
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  case 0x1120: //RTC2 READ
       if (psxHL[0x1114>>2]&0x200) rt[0]=(unsigned short)(rt[0]/16);
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  default:
       rt[0] = (unsigned short)psxHW[addrD >> 1];
  break;
}
}

void READ16SHW(void)
{
unsigned long register addrD, *rt;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

if ((addrD >= 0x1c00) && (addrD < 0x1e00) && SPUDEC) rt[0]=(signed short)SPU_readRegister(addrD|0x1f800000);
else rt[0] = (signed short)psxHW[addrD >> 1];
}

void READ32HW(void)
{
unsigned long register addrD, *rt;
asm("
andl $0xffff, %%eax
" : "=a"(addrD), "=d"(rt) );

if ((addrD >= 0x1c00) && (addrD < 0x1e00) && SPUDEC)
   rt[0]=(unsigned short)SPU_readRegister(addrD|0x1f800000);
else
switch (addrD)
{
  case 0x1810:
       rt[0] = GPU_readData();
       break;
  case 0x1814:
       rt[0] = GPU_readStatus();
       break;

  case 0x1820:
       rt[0] = 0;
       break;

  case 0x1824:
       rt[0] = mdec1_read();
       break;

  case 0x1100: //RTC0 READ
       if (psxHL[0x1104>>2]&0x100) rt[0]=(unsigned short)(rt[0]/5);
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  case 0x1110: //RTC1 READ
       if (psxHL[0x1114>>2]&0x100) rt[0]=(unsigned short)temporizer;
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  case 0x1120: //RTC2 READ
       if (psxHL[0x1114>>2]&0x200) rt[0]=(unsigned short)(rt[0]/16);
       else rt[0]=(unsigned short)psxHL[0x1100>>2];
       break;

  default:
  rt[0]= psxHL[addrD >> 2];
  break;
}
}


void RW(void)
{

asm("
.align 4,0x90
_READ8S:
leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja noHARD8S
jmp _READ8SHW

.align 4,0x90
noHARD8S:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEM(,%eax,4), %eax
movsbl (%eax,%ecx,1),%eax
movl %eax, (%edx)
ret
");

asm("
.align 4,0x90
_READ8U:

leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja noHARD8U
jmp _READ8UHW

.align 4,0x90
noHARD8U:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEM(,%eax,4), %eax
movzbl (%eax,%ecx,1),%eax
movl %eax, (%edx)
ret
");

asm("
.align 4,0x90
_READ16S:
leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja noHARD16S
jmp _READ16SHW

.align 4,0x90
noHARD16S:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEM(,%eax,4), %eax
movswl (%eax,%ecx,1),%eax
movl %eax, (%edx)
ret
");

asm("
.align 4,0x90
_READ16U:

leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja noHARD16U
jmp _READ16UHW

.align 4,0x90
noHARD16U:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEM(,%eax,4), %eax
movzwl (%eax,%ecx,1),%eax
movl %eax, (%edx)
ret
");

asm("
.align 4,0x90
_READ32:

leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja noHARD32
jmp _READ32HW

.align 4,0x90
noHARD32:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEM(,%eax,4), %eax
movl (%eax,%ecx,1),%eax
movl %eax, (%edx)
ret
");

asm("
.align 4,0x90
_WRITE32:
leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja nwHARD32
jmp _WRITE32HW

.align 4,0x90
nwHARD32:
testl $0x10000, _regCOP0+48
jnz bye1

movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEMW(,%eax,4), %eax
movl %edx, (%eax,%ecx,1)
bye1:
ret
");

asm("
.align 4,0x90
_WRITE16:

leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja nwHARD16
jmp _WRITE16HW

.align 4,0x90
nwHARD16:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEMW(,%eax,4), %eax
movw %dx, (%eax,%ecx,1)
ret
");

asm("
.align 4,0x90
_WRITE8:

leal -528486400(%eax),%ecx
cmpl $61439,%ecx
ja nwHARD8
jmp _WRITE8HW

.align 4,0x90
nwHARD8:
movzwl %ax, %ecx
shrl $16, %eax
movl _psxMEMW(,%eax,4), %eax
movb %dl, (%eax,%ecx,1)
ret
");
}

void doSWR(void)
{
unsigned long addrD, rt;
unsigned long *mempoint;
asm("" : "=a"(addrD), "=d"(rt) );
mempoint= (void*)psxMEMW[(addrD>>16)&0xffff]+(addrD&0xfffc);
switch (addrD&3)
 {
		case 3: mempoint[0] = (mempoint[0] & 0x00ffffff) | (rt<<24); break;
		case 2: mempoint[0] = (mempoint[0] & 0x0000ffff) | (rt<<16); break;
		case 1: mempoint[0] = (mempoint[0] & 0x000000ff) | (rt<< 8); break;
		case 0: mempoint[0] = rt; break;
 }
}

void doSWL(void)
{
unsigned long addrD, rt;
unsigned long *mempoint;
asm("" : "=a"(addrD), "=d"(rt) );
mempoint= (void*)psxMEMW[(addrD>>16)&0xffff]+(addrD&0xfffc);
switch (addrD&3)
 {		case 3: mempoint[0] = rt; break;
		case 2: mempoint[0] = (mempoint[0] & 0xff000000) | (rt>> 8); break;
		case 1: mempoint[0] = (mempoint[0] & 0xffff0000) | (rt>>16); break;
		case 0: mempoint[0] = (mempoint[0] & 0xffffff00) | (rt>>24); break;
 }
}

void doLWR(void)
{
unsigned long addrD, *rt;
register unsigned long *mempoint;
asm("" : "=a"(addrD), "=d"(rt) );
mempoint= (void*)psxMEM[(addrD>>16)&0xffff]+(addrD&0xfffc);
switch (addrD&3)
 {		case 0: rt[0] = mempoint[0]; break;
		case 1: rt[0] = (rt[0] & 0xff000000) | (mempoint[0]>> 8); break;
		case 2: rt[0] = (rt[0] & 0xffff0000) | (mempoint[0]>>16); break;
		case 3: rt[0] = (rt[0] & 0xffffff00) | (mempoint[0]>>24); break;
 }
}


void doLWL(void)
{
unsigned long addrD, *rt;
register unsigned long *mempoint;
asm("" : "=a"(addrD), "=d"(rt) );
mempoint= (void*)psxMEM[(addrD>>16)&0xffff]+(addrD&0xfffc);
switch (addrD&3)
 {		case 3: rt[0] = mempoint[0]; break;
		case 2: rt[0] = (rt[0] & 0x000000ff) | (mempoint[0]<< 8); break;
		case 1: rt[0] = (rt[0] & 0x0000ffff) | (mempoint[0]<<16); break;
		case 0: rt[0] = (rt[0] & 0x00ffffff) | (mempoint[0]<<24); break;
 }
}
