int loadRom(char *name, int tam)
{
 FILE *tmpFile;
 tmpFile = fopen(name,"rb");
 if (tmpFile)
  {
  fread(psxR, tam,1,tmpFile);
  fclose(tmpFile);
  return(0);
  }
 else return(1);
}

int loadDev(char *name)
{
 FILE *tmpFile;
 tmpFile = fopen(name,"rb");
 if (tmpFile)
  {
  fread(psxS, 4096, 1, tmpFile);
  fclose(tmpFile);
  return(0);
  }
 else return(1);
}

int psxload(char *name)
{
 EXE_HEADER tmpHead;
 if (name[0]=='\n') return(0);

 if (CDISO) { loadISOEXE(name); return(0); }

 if ((tempfile) = (fopen(name,"rb")))
  {
   fread(&tmpHead,sizeof(EXE_HEADER),1,tempfile);
   fseek(tempfile, 0x800, SEEK_SET);
   fread(psxM+(tmpHead.t_addr&0x01fffff), tmpHead.t_size,1,tempfile);
   fclose(tempfile);
   CleanRec(tmpHead.t_addr&0x01fffff, tmpHead.t_size);
   rPC = tmpHead.pc0;
   reg[28] = tmpHead.gp0;
   reg[29] = tmpHead.saddr;

   asm("movl $_PSXcode, _NextFree");
   setmeml(PSXused,TENER,524288);

   ScanHLE(tmpHead.t_addr&0x01fffff, (tmpHead.t_size)+(tmpHead.t_addr&0x01fffff) );

   return(0);
  }
   else return(1);
}

void resetPS()
{
 setmeml(reg, 0, 8);
 setmeml(regCOP0, 0, 8);
 setmeml(psxM, 0, 1024*512);
 setmeml (psxH, 0, 1024*16);

 rPC=0xbfc00000;
 regCOP0[1]= 0x00000031;
 regCOP0[12]=0xf0400000;
 regCOP0[15]=0x00000230;
 regHI=regLO=0;

 if (loadRom(Configuracion.BIOSfile, 524288))
  {
   salDOS ("ERROR:  Couldn't find SCPH1001.BIN in BIOS directory.\n");
  }

 psxRL[0x7130>>2]=0x00000000;
 psxRL[0x717c>>2]=0x00000000;

 if (NOSTATIC) INITcpu();

 else

 {

#ifdef hleBIOS
 psxRL[0x2B50>>2]=0xec000001;
 psxRL[0x0]=0xec000008;
 psxRL[0x420>>2]=0xec000009;
 psxRL[0x3990>>2]=0xec00000a;
 psxRL[0x3f8c>>2]=0xec00000b;
 psxRL[0x2c50>>2]=0xec00000d;
 psxRL[0x3288>>2]=0xec00000e;
 psxRL[0x2200>>2]=0xec00000f;
 psxRL[0x2230>>2]=0xec000010;
 psxRL[0x3a18>>2]=0xec000012;
 psxRL[0x69ac>>2]=0xec000013;
 psxRL[0x1acc>>2]=0xec000014;
#endif

 INITcpu();

#ifdef hleRAM

 psxML[0x5c4>>2]=psxML[0x510>>2]=psxML[0xa0>>2]=0xec000002;
 psxML[0x5e0>>2]=psxML[0x520>>2]=psxML[0xb0>>2]=0xec000003;
 psxML[0x600>>2]=psxML[0x530>>2]=psxML[0xc0>>2]=0xec000004;
// psxML[0x406c>>2]=0xec000005;
 psxML[0xf40>>2]=0xec000006;
// psxML[0x4304>>2]=0xec00000c;
 psxML[0x61c4>>2]=0xec000011;
 psxML[0x1ec8>>2]=0xec000015;
 psxML[0x1f10>>2]=0xec000016;
 psxML[0x1f4c>>2]=0xec000017;
 psxML[0x1e1c>>2]=0xec000018;
 psxML[0x1b44>>2]=0xec000019;
 psxML[0x1d8c>>2]=0xec00001f;
 psxML[0xc80>>2]=0xec000020;
 psxML[0x80>>2]=0xec000020;
 psxML[0x0>>2]=0xec000020;
 psxML[0xf0c>>2]=0xec000020;
 psxML[0x16ac>>2]=0xec000022;
 psxML[0x2458>>2]=psxML[0x218c>>2]=0xec000021;
 psxML[0x4ac8>>2]=0xec000036;
 psxML[0x2eec>>2]=0xec00003c;
 #ifdef EmuCards
 psxML[0x5E50>>2]=0xec00001a;
 psxML[0x5F04>>2]=0xec00001b;
 psxML[0x2958>>2]=0xec00001c;
 psxML[0x2b28>>2]=0xec00001d;
 psxML[0x2c94>>2]=0xec00001e;
 psxML[0x2e00>>2]=0xec000039;
 psxML[0x39a4>>2]=0xec00003a;
 psxML[0x3a70>>2]=0xec00003b;
 #endif
#endif

 }

 if (psxload(PSXloaded)) salDOS ("ERROR:  Couldn't load the specified Playstation executable.");
}

int loadCNF(void)
{
     FILE *fp;
     unsigned char temp_name[256],letter;
     unsigned long retry=0;

     letter = dCD;

     redo:

     sprintf(temp_name,"%c:/system.cnf",letter);
     if ((fp = fopen(temp_name,"rb")) != NULL)
       {
        fscanf(fp,"BOOT = cdrom:%s;2",temp_name);
        fclose(fp);
        if (temp_name[strlen(temp_name)-2]==';') temp_name[strlen(temp_name)-2] = 0;
        sprintf(PSXloaded,"%c:%s",letter,temp_name);
        return(0);
       }

     sprintf(temp_name,"%c:/psx.exe",letter);
     if ((fp = fopen(temp_name,"rb")) != NULL)
       {
        fclose(fp);
        sprintf(PSXloaded,"%c:/psx.exe",letter);
        return(0);
       }
     retry++;
     if (retry<5) goto redo;

     Beep(900,100);
     retry=MessageBox(opio, "Cannot Boot, check if PSX CDROM is fine.", "AdriPSX Emulator", MB_RETRYCANCEL | MB_ICONSTOP);
     if (retry==IDRETRY) goto redo;

     return(1);
}
