#include <windows.h>

 typedef struct
 {
  int freq;
  int nbits;
  int stereo;
  int nsamples;
  long y0a, y1a, y0b, y1b;
  short pcm[16384];
 } xa_decode_t;

typedef char SoundGroup[128];
typedef struct SoundSector {
        char            sectorFiller[48];
        SoundGroup      SoundGroups[18];
} SoundSector;

extern unsigned long SPUDEC;
extern unsigned long XADEC;
extern unsigned char *RAWCDROM;
extern unsigned long cdFile, cdChannel;
void SPU__playADPCMchannel(xa_decode_t *xap);

#define kNumOfSGs       18
#define kNumOfSamples   224
#define FXD_FxdToPcm16(dt)      (max(min((dt)/2, 32767), -32768))
#define FXD_Pcm16ToFxd(dt)      ((long)dt*2)

xa_decode_t kazuXA;
SoundSector *ssct;

typedef long FXD;

static FXD K0[4] = { 0x00000000, 0x0000F000, 0x0001CC00, 0x00018800 };
static FXD K1[4] = { 0x00000000, 0x00000000, 0xFFFF3000, 0xFFFF2400 };

FXD t1, t2;

static signed char getSoundData(char *buf, long unit, long sample)
{
        signed char register ret;
        asm("
        leal 16(%%eax,%%edx,4), %%eax
        movl %%ecx, %%edx
        sarl $1, %%edx
        addl %%edx, %%eax
        movb (%%eax), %%al
        andl $1, %%ecx
        shll $2, %%ecx
        sarb %%cl, %%al
        shlb $4, %%al
        sarb $4, %%al
        ": "=a"(ret)
         : "a"((void*)buf), "c"(unit), "d"(sample)
         : "%eax", "%ecx", "%edx");
        return ret;
}

#define getFilter(buf,unit) (((((signed char*)(buf+4+unit))[0])>>4)&3)

#define getRange(buf,unit) (((((signed char*)(buf+4+unit))[0]))&0xf)

static FXD FXD_FixMul(FXD a, FXD b)
{
    long register          high_a, low_a, high_b, low_b;
    high_a = a >> 16;
    low_a = a & 0x0000FFFF;
    high_b = b >> 16;
    low_b = b & 0x0000FFFF;
    return (FXD)((long)((high_a*high_b)<<16) + (long)(high_a*low_b) + (long)(low_a*high_b) + (unsigned long)((unsigned long)(low_a*low_b)>>16));
}

static long decodeSoundSect(SoundSector *ssct)
{
        long register count;
        signed char register snddat, filt, range;
        long register unit, sample;
        long register sndgrp;
        FXD tmp2, tmp3, tmp4, tmp5;

        count = 0;

        for (sndgrp = 0; sndgrp < kNumOfSGs; sndgrp++) {
                for (unit = 0; unit < 8; unit++) {
                        range = getRange(ssct->SoundGroups[sndgrp], unit);
                        filt = getFilter(ssct->SoundGroups[sndgrp], unit);
                        for (sample = 0; sample < 28; sample++) {
                                snddat = getSoundData(ssct->SoundGroups[sndgrp], unit, sample);

                                tmp2 = (long)(snddat) << (12 - range);
                                tmp3 = FXD_Pcm16ToFxd(tmp2);
                                tmp4 = FXD_FixMul(K0[filt], t1);
                                tmp5 = FXD_FixMul(K1[filt], t2);
                                t2 = t1;
                                t1 = tmp3 + tmp4 + tmp5;
                                kazuXA.pcm[count++] = FXD_FxdToPcm16(t1);
                        }
                }
        }
        return count;
}

static long decodeSoundSect1(SoundSector *ssct)
{
        long register count;
        signed char register snddat, filt, range;
        long register unit, sample;
        long register sndgrp;
        FXD register tmp2, tmp3, tmp4, tmp5;

        count = 0;

	for (sndgrp = 0; sndgrp < kNumOfSGs; sndgrp++) {
                for (unit = 0; unit < 8; unit+= 2) {
                        range = 12-getRange(ssct->SoundGroups[sndgrp], unit);
                        filt = getFilter(ssct->SoundGroups[sndgrp], unit);

        if (filt == 0)
            for (sample = 0; sample < 28; sample++) {
             snddat = getSoundData(ssct->SoundGroups[sndgrp], unit, sample);
             tmp2 = (long)(snddat) << range;
             tmp3 = FXD_Pcm16ToFxd(tmp2);
             tmp4 = 0;
             tmp5 = 0;
             t2 = t1;
             t1 = tmp3 + tmp4 + tmp5;
             kazuXA.pcm[count++] = FXD_FxdToPcm16(t1);
            }
        else if (filt == 1)
            for (sample = 0; sample < 28; sample++) {
             snddat = getSoundData(ssct->SoundGroups[sndgrp], unit, sample);
             tmp2 = (long)(snddat) << range;
             tmp3 = FXD_Pcm16ToFxd(tmp2);
             tmp4 = FXD_FixMul(0xf000, t1);
             tmp5 = 0;
             t2 = t1;
             t1 = tmp3 + tmp4 + tmp5;
             kazuXA.pcm[count++] = FXD_FxdToPcm16(t1);
            }
        else if (filt == 2)
            for (sample = 0; sample < 28; sample++) {
             snddat = getSoundData(ssct->SoundGroups[sndgrp], unit, sample);
             tmp2 = (long)(snddat) << range;
             tmp3 = FXD_Pcm16ToFxd(tmp2);
             tmp4 = FXD_FixMul(0x0001CC00, t1);
             tmp5 = FXD_FixMul(0xFFFF3000, t2);
             t2 = t1;
             t1 = tmp3 + tmp4 + tmp5;
             kazuXA.pcm[count++] = FXD_FxdToPcm16(t1);
            }
        else if (filt == 3)
            for (sample = 0; sample < 28; sample++) {
             snddat = getSoundData(ssct->SoundGroups[sndgrp], unit, sample);
             tmp2 = (long)(snddat) << range;
             tmp3 = FXD_Pcm16ToFxd(tmp2);
             tmp4 = FXD_FixMul(0x00018800, t1);
             tmp5 = FXD_FixMul(0xFFFF2400, t2);
             t2 = t1;
             t1 = tmp3 + tmp4 + tmp5;
             kazuXA.pcm[count++] = FXD_FxdToPcm16(t1);
            }

               }
        }
        return count;
}

void doXA(void)
{
if (SPUDEC && XADEC)
  {
   if   ( ((RAWCDROM[22]&0x64) == 0x64))
   {
    if ((RAWCDROM[20] =! cdFile)|| (RAWCDROM[21] != cdChannel) ) return;

    ssct = (void *)RAWCDROM-24;

    if (RAWCDROM[23]&1) kazuXA.nsamples=decodeSoundSect1(ssct);
    else kazuXA.nsamples=decodeSoundSect(ssct);

    if (RAWCDROM[23]&4) kazuXA.freq=18900;
    else kazuXA.freq=37800;

    kazuXA.nbits=16;
    kazuXA.stereo=0;
    SPU__playADPCMchannel(&kazuXA);
    return;
   }
  }
}
